Attribute VB_Name = "CommonDLG"
Option Explicit
'Private Const LF_FACESIZE = 32
'Private Const CF_ANSIONLY = &H400&
'Private Const CF_APPLY = &H200&
'Private Const CF_BITMAP = 2
Private Const CF_BOTH = &H3 '(CF_SCREENFONTS Or CF_PRINTERFONTS)
'Private Const CF_DIB = 8
'Private Const CF_DIF = 5
'Private Const CF_DSPBITMAP = &H82
'Private Const CF_DSPENHMETAFILE = &H8E
'Private Const CF_DSPMETAFILEPICT = &H83
'Private Const CF_DSPTEXT = &H81
Private Const CF_EFFECTS = &H100&
'Private Const CF_ENABLEHOOK = &H8&
'Private Const CF_ENABLETEMPLATE = &H10&
'Private Const CF_ENABLETEMPLATEHANDLE = &H20&
'Private Const CF_ENHMETAFILE = 14
'Private Const CF_FIXEDPITCHONLY = &H4000&
'Private Const CF_FORCEFONTEXIST = &H10000
'Private Const CF_GDIOBJFIRST = &H300
'Private Const CF_GDIOBJLAST = &H3FF
Private Const CF_INITTOLOGFONTSTRUCT = &H40&
'Private Const CF_LIMITSIZE = &H2000&
'Private Const CF_METAFILEPICT = 3
'Private Const CF_NOFACESEL = &H80000
'Private Const CF_NOOEMFONTS = CF_NOVECTORFONTS
Private Const CF_NOSCRIPTSEL = &H800000
'Private Const CF_NOSIMULATIONS = &H1000&
'Private Const CF_NOSIZESEL = &H200000
'Private Const CF_NOSTYLESEL = &H100000
'Private Const CF_NOVECTORFONTS = &H800&
'Private Const CF_NOVERTFONTS = &H1000000
'Private Const CF_OEMTEXT = 7
'Private Const CF_OWNERDISPLAY = &H80
'Private Const CF_PALETTE = 9
'Private Const CF_PENDATA = 10
'Private Const CF_PRINTERFONTS = &H2
'Private Const CF_PRIVATEFIRST = &H200
'Private Const CF_PRIVATELAST = &H2FF
'Private Const CF_RIFF = 11
'Private Const CF_SCALABLEONLY = &H20000
'Private Const CF_SCREENFONTS = &H1
'Private Const CF_SCRIPTSONLY = CF_ANSIONLY
'Private Const CF_SELECTSCRIPT = &H400000
'Private Const CF_SHOWHELP = &H4&
'Private Const CF_SYLK = 4
'Private Const CF_TEXT = 1
'Private Const CF_TIFF = 6
'Private Const CF_TTONLY = &H40000
'Private Const CF_UNICODETEXT = 13
'Private Const CF_USESTYLE = &H80&
'Private Const CF_WAVE = 12
'Private Const CF_WYSIWYG = &H8000
Private Const BOLD_FONTTYPE = &H100
Private Const ITALIC_FONTTYPE = &H200

'OPEN DIALOG BOXES-------------------------------------------------
Private Declare Function GetOpenFileName Lib "COMDLG32.DLL" Alias "GetOpenFileNameA" (lpOpenFileName As OPENFILENAME) As Long
Private Type OPENFILENAME
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
'SAVE DIALOG BOX---------------------------------------------------
Private Declare Function GetSaveFileName Lib "COMDLG32.DLL" Alias "GetSaveFileNameA" (lpOpenFileName As OPENFILENAME) As Long
'PRIVATE Type OPENFILENAME
'FOLDER SELECTION DIALOG BOX---------------------------------------
Private Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "ShBrowseForFolderA" (lpbrowseinfo As BROWSEINFO) As Long

Private Type BROWSEINFO
hOwner As Long
pidlRoot As Long
pszDisplayRoot As String
lpszTitle As String
ulFlags As Long
lpfn As Long
lparam As Long
iImage As Long
End Type

'COLOR DIALOG BOX--------------------------------------------------
Private Declare Function ChooseColor Lib "COMDLG32.DLL" Alias "ChooseColorA" (lpChooseColor As UDTChooseColor) As Long
Private Type UDTChooseColor
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    rbgResult As Long
    lpCustColor As String
    Flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

'FONT DIALOG BOX---------------------------------------------------
Private Declare Function ChooseFont Lib "COMDLG32.DLL" Alias "ChooseFontA" (pChoosefont As ChooseFont) As Long
Private Type ChooseFont
        lStructSize As Long
        hWndOwner As Long          '  caller's window handle
        hdc As Long                '  printer DC/IC or NULL
        lpLogFont As Long
        iPointSize As Long         '  10 * size in points of selected font
        Flags As Long              '  enum. type flags
        rgbColors As Long          '  returned text color
        lCustData As Long          '  data passed to hook fn.
        lpfnHook As Long           '  ptr. to hook function
        lpTemplateName As String     '  custom template name
        hInstance As Long          '  instance handle of.EXE that
                                       '    contains cust. dlg. template
        lpszStyle As String          '  return the style field here
                                       '  must be LF_FACESIZE or bigger
        nFontType As Integer          '  same value reported to the EnumFonts
                                       '    call back with the extra FONTTYPE_
                                       '    bits added
        MISSING_ALIGNMENT As Integer
        nSizeMin As Long           '  minimum pt size allowed &
        nSizeMax As Long           '  max pt size allowed if
                                       '    CF_LIMITSIZE is used
End Type
Private Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName As String * 255
End Type

'PRINT DIALOG BOX--------------------------------------------------
Private Declare Function GetPrinter Lib "winspool.drv" Alias "GetPrinterA" (ByVal hPrinter As Long, ByVal Level As Long, pPrinter As Any, ByVal cbBuf As Long, pcbNeeded As Long) As Long

'NETWORK DIALOG BOXES----------------------------------------------

'===========================================================================================
'=================ALL PUBLIC METHODES ,INTERFACE TO THIS MODULE=============================
'===========================================================================================
Public Function ShowOpen(hwnd As Long _
                        , Optional Filter As String = "All Files *.*|*.*" _
                        , Optional Caption As String = "Open" _
                        , Optional InitDir As String _
                        , Optional MultiSelect As Boolean = False _
                        , Optional HideReadOnly As Boolean = False _
                        , Optional ReadOnly As Boolean = False _
                        , Optional FileMustExist As Boolean = True _
                        , Optional Flags As Long) As String

Dim Ret As Long, P_OFN As OPENFILENAME
Dim FLAG As Long
Const MAX_BUFFER_LENGTH = 260

Dim ch As String, i As Integer, s As String
    
FLAG = (-FileMustExist * &H1000) Or _
       (-MultiSelect * &H200) Or _
       (-ReadOnly * &H1) Or _
       (-HideReadOnly * &H4) Or _
       (Flags And CLng(Not (&H20 Or &H40)))
    
    For i = 1 To Len(Filter)
        ch = Mid$(Filter, i, 1)
        If ch = "|" Then
            s = s & vbNullChar
        Else
            s = s & ch
        End If
    Next
Filter = s

With P_OFN
    .hInstance = App.hInstance
    .hWndOwner = hwnd
    .lpstrTitle = Caption
    .lpstrInitialDir = InitDir
    .lpstrFilter = Filter
    .nFilterIndex = 1
    .lpstrFile = Chr$(0) & Space$(MAX_BUFFER_LENGTH - 1)
    .nMaxFile = MAX_BUFFER_LENGTH
    .lpstrFileTitle = .lpstrFile
    .nMaxFileTitle = MAX_BUFFER_LENGTH - 1
    .Flags = FLAG
    .lStructSize = Len(P_OFN)
End With

Ret = GetOpenFileName(P_OFN)

If Ret Then
    ShowOpen = Left$(P_OFN.lpstrFile, P_OFN.nMaxFile)
    ShowOpen = Trim(ShowOpen)
    ShowOpen = Mid(ShowOpen, 1, Len(ShowOpen) - 1)

Else
    ShowOpen = ""
End If
    'Label1.Caption = O.lpstrFile
End Function

Public Function ShowSave(hwnd As Long _
                        , Optional Filter As String = "All Files *.*|*.*" _
                        , Optional Caption As String = "Save" _
                        , Optional DefExtention As String = ".txt") As String
                        
Dim Ret As Long, pOpenfilename As OPENFILENAME
Dim IPos As Integer
Const MAX_BUFFER_LENGTH = 256

Dim ch As String, i As Integer, s As String
    For i = 1 To Len(Filter)
        ch = Mid$(Filter, i, 1)
        If ch = "|" Then
            s = s & vbNullChar
        Else
            s = s & ch
        End If
    Next
Filter = s

With pOpenfilename
    .hWndOwner = hwnd
    .hInstance = App.hInstance
    .lpstrTitle = Caption
    .lpstrInitialDir = App.PATH
    .lpstrFilter = Filter '"All Files" & Chr$(0) & "*.*" & Chr$(0)
    .nFilterIndex = 0
    .lpstrDefExt = DefExtention
    .lpstrFile = String(MAX_BUFFER_LENGTH, 0)
    .nMaxFile = MAX_BUFFER_LENGTH - 1
    .lpstrFileTitle = .lpstrFile
    .nMaxFileTitle = MAX_BUFFER_LENGTH
    .lStructSize = Len(pOpenfilename)
End With

Ret = GetSaveFileName(pOpenfilename)
If Ret Then
    ShowSave = pOpenfilename.lpstrFile
    IPos = InStr(1, ShowSave, vbNullChar)
    ShowSave = Mid(ShowSave, 1, IPos - 1)
Else
    ShowSave = ""
End If
End Function

Public Sub ShowFolder(hwnd As Long)
Dim BI As BROWSEINFO, Ret As Long
BI.hOwner = hwnd
'BI.pidlRoot = "Desktop"
'bi.pszDisplayRoot =
BI.lpszTitle = "Select A Folder" & Chr$(0)
BI.ulFlags = &H1
'bi.lpfn =
'bi.lparam =
'bi.iImage =
Call SHBrowseForFolder(BI)
End Sub

Public Function ShowColor()
Dim Ret As Long, PCC As UDTChooseColor
Dim CustomColors() As Byte
With PCC
    .hWndOwner = 0
    .hInstance = App.hInstance
    .lpCustColor = StrConv(CustomColors, vbUnicode)
    .Flags = 0
    
    .lStructSize = Len(PCC)
End With

Ret = ChooseColor(PCC)
If Ret Then
    ShowColor = PCC.rbgResult
End If
End Function

Public Sub ShowFont(hwnd As Long _
                    , Optional FontName As String = "Courier New" _
                    , Optional FontSize As Integer = 10 _
                    , Optional Bold As Boolean = False _
                    , Optional Italic As Boolean = False _
                    , Optional UnderLine As Boolean = False _
                    , Optional Color As Long = vbBlack _
                    )
Dim RC As Long
Dim PF As ChooseFont
Dim LF As LOGFONT
Dim IPos As Integer

With LF
    .lfFaceName = FontName & Chr$(0)
    .lfItalic = Italic
    .lfUnderline = UnderLine
   ' .lfHeight = 10
   
End With
With PF
    .hInstance = App.hInstance
    .hWndOwner = hwnd
    .Flags = CF_BOTH + CF_INITTOLOGFONTSTRUCT + CF_EFFECTS + CF_NOSCRIPTSEL
    .iPointSize = -(FontSize * 10)
    If Bold = True Then .nFontType = .nFontType + BOLD_FONTTYPE
    If Italic = True Then .nFontType = .nFontType + ITALIC_FONTTYPE
    
    .rgbColors = Color
    
    .lStructSize = Len(PF)
    .lpLogFont = VarPtr(LF)
End With
RC = ChooseFont(PF)
If RC Then
    FontName = StrConv(LF.lfFaceName, vbUnicode)
    IPos = InStr(FontName, vbNullChar)
    FontName = Left$(FontName, (IPos - 1))
    With PF
        FontSize = .iPointSize / 10
    End With
End If
End Sub

Public Sub ShowPrint()

End Sub
